#include "bootstrap.h"
#include "klibdb/kdbm.h"
 
main(
   int  argc,
   char *argv[],
   char *envp[])
{
	kdatum key, data;
	kdbm *odbm, *ndbm;
	char *opath, *npath;

	if (argc > 2)
	{
	   opath = argv[1];
	   npath = argv[2];
	}
	else
	{
	   kfprintf(kstderr,"Usage: example {in file} {out file}\n");
	   exit(1);
	}

	if ((odbm = kdbm_open(opath, O_RDONLY, 0666)) != NULL &&
	    (ndbm = kdbm_open(npath, O_WRONLY|O_CREAT|O_TRUNC, 0666)) != NULL)
	{
	   for (key = kdbm_firstkey(odbm); key.dptr != NULL;
		key = kdbm_nextkey(odbm))
	   {
	      data = kdbm_fetch(odbm, key);
	      kdbm_store(ndbm, key, data, KDBM_REPLACE);
	   }
	   kdbm_close(odbm);
	   kdbm_close(ndbm);
	}
	kexit(0);
}
