 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgsin.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgsin_get_args
| 
|       Purpose: Gets command line args for kgsin
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgsin
|          Date: Apr 08, 1995
| Modifications: 
| 
------------------------------------------------------------*/
void kgsin_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for kgsin is out of sync with arguments specified in kgsin's *.pane file; please rerun ghostwriter on kgsin.";


	/*
	 * allocate the kgsin structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((unsigned)1, (unsigned) sizeof (clui_info_struct));

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsize",
			  &(clui_info->dsize_int),
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsize",
			  &(clui_info->tsize_int),
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "esize",
			  &(clui_info->esize_int),
			  &(clui_info->esize_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wnum",
			  &(clui_info->wnum_double),
			  &(clui_info->wnum_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wp",
			  &(clui_info->wp_double),
			  &(clui_info->wp_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hnum",
			  &(clui_info->hnum_double),
			  &(clui_info->hnum_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hp",
			  &(clui_info->hp_double),
			  &(clui_info->hp_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dnum",
			  &(clui_info->dnum_double),
			  &(clui_info->dnum_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dp",
			  &(clui_info->dp_double),
			  &(clui_info->dp_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tnum",
			  &(clui_info->tnum_double),
			  &(clui_info->tnum_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tp",
			  &(clui_info->tp_double),
			  &(clui_info->tp_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "enum",
			  &(clui_info->enum_double),
			  &(clui_info->enum_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ep",
			  &(clui_info->ep_double),
			  &(clui_info->ep_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sin1",
			  &(clui_info->sin1_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ampl",
			  &(clui_info->ampl_double),
			  &(clui_info->ampl_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sin5",
			  &(clui_info->sin5_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wampl",
			  &(clui_info->wampl_double),
			  &(clui_info->wampl_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hampl",
			  &(clui_info->hampl_double),
			  &(clui_info->hampl_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dampl",
			  &(clui_info->dampl_double),
			  &(clui_info->dampl_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tampl",
			  &(clui_info->tampl_double),
			  &(clui_info->tampl_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "eampl",
			  &(clui_info->eampl_double),
			  &(clui_info->eampl_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



