 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "ksegcmp.h"
/*-----------------------------------------------------------
| 
|  Routine Name: ksegcmp_get_args
| 
|       Purpose: Gets command line args for ksegcmp
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname ksegcmp
|          Date: Apr 08, 1995
| Modifications: 
| 
------------------------------------------------------------*/
void ksegcmp_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for ksegcmp is out of sync with arguments specified in ksegcmp's *.pane file; please rerun ghostwriter on ksegcmp.";


	/*
	 * allocate the ksegcmp structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((unsigned)1, (unsigned) sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "cast",
			  &(clui_info->cast_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tol",
			  &(clui_info->tol_double),
			  &(clui_info->tol_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "sat",
			  &(clui_info->sat_logic),
			  &(clui_info->sat_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "oat",
			  &(clui_info->oat_logic),
			  &(clui_info->oat_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "s",
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "psum",
			  &(clui_info->psum_logic),
			  &(clui_info->psum_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "pos",
			  &(clui_info->pos_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "i1val",
			  &(clui_info->i1val_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "i1type",
			  &(clui_info->i1type_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "i2val",
			  &(clui_info->i2val_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "i2type",
			  &(clui_info->i2type_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "rt",
			  &(clui_info->rt_logic),
			  &(clui_info->rt_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "var",
			  &(clui_info->var_string),
			  &(clui_info->var_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "all",
			  &(clui_info->all_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "val",
			  &(clui_info->val_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mask",
			  &(clui_info->mask_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "loc",
			  &(clui_info->loc_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "time",
			  &(clui_info->time_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "map",
			  &(clui_info->map_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "segment",
			  &(clui_info->segment_string),
			  &(clui_info->segment_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



