 /*
  * Khoros: $Id$
  */

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the image panicon
   >>>>		       widget.
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Jun 29, 1993
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_PanIconP_h_
#define _xvisual_PanIconP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/ImageP.h>
#include <xvisual/PanIcon.h>


    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwPanIconWidgetClass
{
    XtPointer  extension;
} XvwPanIconWidgetClassPart;


typedef struct _XvwPanIconWidgetClassRec
{
    CoreClassPart		core_class;
    CompositeClassPart		composite_class;
    ConstraintClassPart		constraint_class;
    XvwManagerWidgetClassPart	manager_class;
    XvwGraphicsWidgetClassPart	graphics_class;
    XvwColorWidgetClassPart	color_class;
    XvwImageWidgetClassPart	image_class;
    XvwPanIconWidgetClassPart	panicon_class;
} XvwPanIconWidgetClassRec;

typedef struct _XvwPanIconPart
{
    Dimension	size;
    Position 	xpos;
    Position 	ypos;
    Dimension	width;
    Dimension	height;

    double	factor;
    int         max_width;
    int         max_height;
    Pixel	black;
    Pixel	white;
} XvwPanIconPart;

typedef struct _XvwPanIconWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwGraphicsPart	graphics;
    XvwColorPart	color;
    XvwImagePart	image;
    XvwPanIconPart	panicon;
} XvwPanIconWidgetRec;


typedef struct  _XvwPanIconWidgetClassRec     *XvwPanIconWidgetClass;
typedef struct  _XvwPanIconWidgetRec          *XvwPanIconWidget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwPanIconWidget
 */
extern  XvwPanIconWidgetClassRec xvwPanIconWidgetClassRec;


#endif /* _xvisual_PanIconP_h_ */
/* Don't add after this point */
